// Console based test program for excercising the COM API.

#include <stdio.h>
#include <shlwapi.h>

// All programs using the Synaptics COM SDK include SynKit.h
#include "SynKit.h"

int main(int argc, char *argv[])
{
	int ch/*,x,y,z,w*/;
	//int c[7];
	int v;
	printf("Synaptics MIDIfier\n");
	printf("Written 2005 by Sven Killig <sven@killig.de>\n");
	if(argc<2) {
		printf("Usage: SynapticsMIDI.exe <MIDI port or -1>\n");// <X> [<Y> [<pressure> [<width>]]]\n");
	  return 1;
	}

	union { 
      DWORD dwData; 
      BYTE bData[4]; 
  } u; 
	HMIDIOUT lphmo;
	StrToIntEx(argv[1],STIF_SUPPORT_HEX,&ch);
	midiOutOpen(&lphmo,ch,NULL,NULL,CALLBACK_NULL);

	//for(int i=2;i<argc;i++) StrToIntEx(argv[2],STIF_SUPPORT_HEX,&c[i-2]);
	/*StrToIntEx(argv[2],STIF_SUPPORT_HEX,&x);
	StrToIntEx(argv[3],STIF_SUPPORT_HEX,&y);
	StrToIntEx(argv[4],STIF_SUPPORT_HEX,&z);
	StrToIntEx(argv[5],STIF_SUPPORT_HEX,&w);*/

	ISynAPI *pAPI = 0;
  HRESULT result = SynCreateAPI(&pAPI);
  if (result)
  {
    printf("Cannot obtain an API object, error: %.8x.\n", result);
    exit(-1);
  }

  // Test some API properties.
  long lValue = 0;
  result = pAPI->GetProperty(SP_Version, &lValue);

  TCHAR tBuf[256];
  long lBufLen = sizeof(tBuf);
  result = pAPI->GetStringProperty(SP_VersionString, tBuf, &lBufLen);

  printf("API version: %.8x.\n", lValue);
  printf("Synaptics Driver version: %s.\n", tBuf);

  // Find a device, preferentially a TouchPad or Styk.
  ISynDevice *pDevice = 0;
  long lHandle = -1;
  if ((pAPI->FindDevice(SE_ConnectionAny, SE_DeviceTouchPad, &lHandle) &&
       pAPI->FindDevice(SE_ConnectionAny, SE_DeviceStyk, &lHandle) &&
       pAPI->FindDevice(SE_ConnectionAny, SE_DeviceAny, &lHandle)) || 
      pAPI->CreateDevice(lHandle, &pDevice))
  {
    printf("Unable to find a Synaptics Device.\n");
    exit(-1);
  }

	//pDevice->Acquire(0);

  // Test some device properties.
  result = pDevice->GetProperty(SP_Handle, &lValue);
  result = pDevice->GetProperty(SP_DeviceType, &lValue);
  printf("Found device type: %d,", lValue);
  result = pDevice->GetProperty(SP_ConnectionType, &lValue);
  printf("Connection type: %d.\n", lValue);


  lBufLen = sizeof(tBuf);
  result = pDevice->GetStringProperty(SP_ModelString, tBuf, &lBufLen);
  printf("Device Model ID: %s.\n", tBuf);
  lBufLen = sizeof(tBuf);
  result = pDevice->GetStringProperty(SP_PnPID, tBuf, &lBufLen);
  printf("Device PnP ID: %s.\n", tBuf);
  lBufLen = sizeof(tBuf);
  result = pDevice->GetStringProperty(SP_ShortName, tBuf, &lBufLen);
  printf("Device Config Key: %s.\n", tBuf);

  // Create a unique global named event.
  HANDLE hEvent = 0;
  for (int iInstance = 0; ; iInstance++) 
  {
    char EventName[32];
    sprintf(EventName, "SynCom%d", iInstance);
    hEvent = CreateEvent(0, 0, 0, EventName);

    if (GetLastError() != ERROR_ALREADY_EXISTS)
      break;
  }

  // Setup notification of API, device, and display events.
  pAPI->SetEventNotification(hEvent);
  pDevice->SetEventNotification(hEvent);

  printf("Entering packet processing loop.\n");
  printf("Press <CTRL>+C to exit the program.\n");

  // Loop until a device packet that contains a button or tap event occurs.
  SynPacket Packet;
  for (; ; )
  {
    WaitForSingleObject(hEvent, INFINITE);
    
    for ( ; ; )
    {
      long lParameter = 0;
      result = pAPI->GetEventParameter(&lParameter);
      if (result != S_OK)
        break;

      printf("API event parameter: %d.\n", lParameter);
    }

    for ( ; ; )
    {
      result = pDevice->LoadPacket(Packet);
      if (result == SYNE_FAIL)
        break;

      //printf("%d %d %d %d\n",Packet.X(),Packet.Y(),Packet.Z(),Packet.W());


			u.bData[3] = 0;
			/*for(int i=2;i<argc;i++) {
			u.bData[0] = c[];
			u.bData[1] = ((Packet.X()-1024)*127)/6000;
			u.bData[2] = 0x7f;
			midiOutShortMsg(lphmo,u.dwData);
			}*/
			u.bData[0] = 0xe0;
			v=((Packet.X()-1024)*16383)/5000;
			u.bData[1] = LOBYTE(v);
			u.bData[2] = HIBYTE(v);
			midiOutShortMsg(lphmo,u.dwData);
			u.bData[0] = 0xb0;
			u.bData[1] = 1;
			u.bData[2] = ((Packet.Y()-1024)*127)/4000;
			midiOutShortMsg(lphmo,u.dwData);
			u.bData[1] = 2;
			u.bData[2] = ((Packet.Z())*127)/128;
			midiOutShortMsg(lphmo,u.dwData);
			u.bData[1] = 3;
			u.bData[2] = ((Packet.W())*127)/16;
			midiOutShortMsg(lphmo,u.dwData);
			/*u.bData[1] = 4;
			u.bData[2] = Packet.ButtonState() && SF_ButtonLeft ? 127:0;
			midiOutShortMsg(lphmo,u.dwData);
			u.bData[1] = 5;
			u.bData[2] = Packet.ButtonState() && SF_ButtonRight ? 127:0;
			midiOutShortMsg(lphmo,u.dwData);*/


      /*if ((Packet.FingerState() & SF_FingerTap) || Packet.ButtonState())
      {
        exit(0);
      }*/
			//Sleep(100);
    }
  }

  //pDevice->Unacquire();
	
	pDevice->Release();
  pAPI->Release();

	midiOutClose(lphmo);

  return 0;
}

